<template>
  <!-- <p> -->
  <!--   <button @click="showModal"> -->
  <!--     Show modal -->
  <!--   </button> -->
  <!-- </p> -->
  <Modal
    v-if="isShow"
    v-slot="{ emitClose }"
    :close="closeModal"
  >
    <div class="modal">
      <div class="connectActionDiv">
        <ul class="ulMenu" style="margin: inherit;">
          <menu class="menuButton">
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" @click="emitClose">
              <!-- <a class="aButtonMenu" v-on:click="returnToHome()"> -->
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'arrow-left']" size="1x"/></i><br>
                <span class="spanButtonMenu">Volver</span>
              </a>
            </li>
          </menu>
        </ul>
      </div>
      <p class="msgConnect">
        Conectate a la mini-computadora y envía un programa
      </p>
      <p class="msgConnect">Selecciona el medio de conexión</p>
      <div class="connectActionDiv">
        <ul class="ulMenu">
          <menu class="menuButton">
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" v-on:click="returnToHome()">
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'wifi']" size="1x"/></i><br>
                <span class="spanButtonMenu">WiFi</span>
              </a>
            </li>
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" v-on:click="returnToHome()">
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'plug']" size="1x"/></i><br>
                <span class="spanButtonMenu">USB</span>
              </a>
            </li>
          </menu>
        </ul>
      </div>
      <div>
        <div>
          <div>
            <span class="msgConnect">IP: </span>
            <input v-model="ipMsg" placeholder="192.168.4.1" />
          </div>
          <div>
            <span class="msgConnect">PORT: </span>
            <input v-model="portMsg" placeholder="1522" />
          </div>
        </div>
        <div hidden>
          <div class="msgConnect">Selected: {{ selected }}</div>

          <select v-model="selected">
            <option disabled value="">Please select one</option>
            <option>A</option>
            <option>B</option>
            <option>C</option>
          </select>
        </div>
      </div>
      <p class="msgConnect">Progreso de la orden</p>
      <div>
        <progress class="msgConnect classMessage" value="50" max="100">50 %</progress>
      </div>
      <div class="connectActionDiv">
        <ul class="ulMenu">
          <menu class="menuButton">
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" v-on:click="returnToHome()">
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'paper-plane']" size="1x"/></i><br>
                <span class="spanButtonMenu">Enviar</span>
              </a>
            </li>
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" v-on:click="returnToHome()">
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'trash-can']" size="1x"/></i><br>
                <span class="spanButtonMenu">Eliminar</span>
              </a>
            </li>
            <li class="liButtonMenu">
              <!-- <a href="#"> -->
              <a class="aButtonMenu" v-on:click="returnToHome()">
                <i class="iButtonMenu"><font-awesome-icon :icon="['fas', 'power-off']" size="1x"/></i><br>
                <span class="spanButtonMenu">Reiniciar</span>
              </a>
            </li>
          </menu>
        </ul>
      </div>
      <div>
        <button @click="emitClose">
          cerrar
        </button>
      </div>
      <div>
        <p class="msgConnect classMessage">
        {{ message }}
        </p>
      </div>
    </div>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, ref, watch, onMounted } from 'vue'

/* -- ICONS BUTTONS --*/
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
import { library } from '@fortawesome/fontawesome-svg-core'
import { faArrowLeft, faPaperPlane, faSave, faTrashCan, faPowerOff, faWifi, faPlug } from '@fortawesome/free-solid-svg-icons'
library.add(faArrowLeft, faPaperPlane, faSave, faTrashCan, faPowerOff, faWifi, faPlug)

export default defineComponent({

  components: {
    'font-awesome-icon': FontAwesomeIcon
  },
  // props: {
  //  message: {
  //    type: string,
  //    default: 'mi mensaje'
  //  }
  // },
  props: ['parentMessage', 'trigger'],
  setup (props) {
    const isShow = ref(false)
    const message = ref()

    function showModal () {
      isShow.value = true
    }

    function closeModal () {
      isShow.value = false
    }

    watch(() => props.trigger, (msg, oldMsg) => {
      message.value = props.parentMessage
      console.log('watch: ', 'trigger value actual: ', msg, '\ntrigger value old: ', oldMsg, '\nthis message_: ', message.value)
      // console.log(props.parentMessage)
      showModal()
    })

    onMounted(() => {
      // console.log(props.parentMessage)
    })

    return {
      isShow,
      showModal,
      closeModal,
      message
    }
  }
})
</script>

<style>

/* -- MODAL --*/
.modal {
  width: auto;
  /* width: 300px;*/
  padding: 10px;
  box-sizing: border-box;
  background-color: rgba(19, 28, 33, 1);
  font-size: 20px;
  text-align: center;
  position: absolute;
  top: 20px;
  bottom: 20px;
  overflow: scroll;
}
.vue-universal-modal {
  z-index: 71;
}

/* -- TEXT --*/
.classMessage {
  height: auto;
  text-align: left;
  white-space: pre; /* habilita \n y \t para <p> */
}
.msgConnect {
  color: white;
}

/* -- CONNECT ACTION -- */
.connectActionDiv {
  display: flex;
}

/* -- BUTTONS --*/
.ulMenu {
  position: relative;
  padding: 0px 0px 0px 0px;
  /* top: 0px; /**/
  margin: auto;
  /* margin-left: -40px;*/
  width  : auto;
}
.menuButton {
  /* position: fixed; /**/
  padding: 0px 0px 0px 0px;
  /* left: 0px; /**/
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
}
.liButtonMenu {
  list-style-type : none;
  /* TODO STYLE */
  /* background      : linear-gradient(rgba(220,220,255,0) 85%, rgba(255,255,255,0) 100%); /**/
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.0);
  border-bottom : 2px solid rgba(50,50,50,0.0);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

.liButtonMenu:first-child {
  border-radius : 5px 0 0 5px;
}

.liButtonMenu:last-child {
  border-radius : 0 5px 5px 0;
}

.iButtonMenu {
  padding: 0px 0px;
  margin: 0px 0px 0px 0px;
}

.aButtonMenu {
  display : block;
  text-align: center;
  line-height: 0.5;
  padding : 8px 8px; /* 10px 13px */
  font-size : 20px;   /* 26px */
  text-decoration : none;
  border-radius   : 20px;
  position        : relative;
  top   : 0;
  color : #FFF;
  transition : all .4s;
  z-index: 71;
}

.aButtonMenu:hover{
  background: rebeccapurple;
}

.spanButtonMenu {
  display: inline-block;
  font-size: 12px;
  pointer-events: none;
  padding : 0px 0px;
  margin: 0px 0px 0px 0px;
}

/*li:hover a {*/
.liButtonMenu:active .aButtonMenu {
  /* TODO STYLE */
  top   : -5px; /* - arriba + abajo Desplazamiento al poner el cursor sobre el boton */
  color : black; /* color to convert skyBlue #4eacff*/
  background-color: #fff;
  box-shadow : 0 0 5px 0 rgba(255, 255, 255, 0.7);
  transition : all .1s;
  border-color : dark;
}

.liButtonMenu .aButtonMenu:after {
  display  : block;
  content  : '';
  position : relative;
  top  : 100%;
  /*left : 0%; /**/
  border-style : solid;
  border-color : transparent;
  border-width : 5px 5px 0 5px;
  transition   : all .4s;
}

/*li:hover a:after {*/
.liButtonMenu:active .aButtonMenu:after {
  border-color : white transparent transparent transparent;
  transition   : all 0.7s;
}


</style>
